﻿using System.Drawing;
using DicomObjects;
using DicomObjects.Enums;

namespace DicomWebViewer
{
    public class JsDicomImage
    {
        public string id;
        public float width, level, zoom = 0;
        public PointF scroll;
        public Size size;
        public bool html5;
        public int n;
        public string format;

        public JsDicomImage(DicomImage image)
        {
            id = image.InstanceUID;
            width = image.Width;
            level = image.Level;
            size = image.Size;
            var imageDataSetPhotometricInterpretation = (string)image.DataSet[Keyword.PhotometricInterpretation].Value;
            html5 = image.Size.Width < 1000 && (imageDataSetPhotometricInterpretation != null && imageDataSetPhotometricInterpretation.StartsWith("MONO"));
            n = -1;

            if (image is DicomWebViewer.HtmlDicomImage)
            {
                format = (image as DicomWebViewer.HtmlDicomImage).Format;

            }
        }
    }
}
