﻿// uncertain
var count = 0;

var imageData = new Array();


// our "global" object
var DicomImageViewer =
{
    jsDicomImageRenderBase: function (viewer, data, t) {

        DicomImageViewer.SetSize(data, viewer);

        return viewer.data.guid + "/" + t + "?" +
            "ImageID=" + data.id +
            "&CellHeight=" + (viewer.clientHeight / viewer.data.multiRows) +
            "&CellWidth=" + (viewer.clientWidth / viewer.data.multiColumns) +
            "&ScrollX=" + data.scroll.X +
            "&ScrollY=" + data.scroll.Y +
            "&Zoom=" + data.zoom;
    },


    jsDicomImageRenderJpegSrc: function (viewer, t, back) {

        var output = "";
        var w = back ? 200 : this.data.width;
        var l = back ? 100 : this.data.level;

        var type = this.data.format || "PNG";

        output += DicomImageViewer.jsDicomImageRenderBase(viewer, this.data, type) +
        "&Width=" + w +
        "&Level=" + l +
        "&Text=" + t;
        this.o_width = this.data.width;
        this.o_level = this.data.level;
        return encodeURI(output);
    },

    // as function to give context to the closure
    loadDataHTML5: function (viewer, image, ds) {

        DicomImageViewer.SetSize(image.data, viewer);
        if (ds == undefined)
            ds = DicomImageViewerUtils.power2Round(1 / image.data.zoom);

        var thisImageData = imageData[image.data.id];

        if (thisImageData === undefined) {
            thisImageData = new Object();
            imageData[image.data.id] = thisImageData;
        }

        if (typeof thisImageData[ds] === "undefined") {
            thisImageData[ds] = "requested";

            $.getJSON(DicomImageViewer.jsDicomImageRenderBase(viewer, image.data, "DATA"),
               { Downsample: ds },
               function (pd) {

                   if (thisImageData[pd.downsample] === "requested" ||
                        typeof thisImageData[pd.downsample] === "undefined") {

                       thisImageData[pd.downsample] = pd;
                       image.render = DicomImageViewer.jsDicomViewerRenderCanvas;
                       image.render(viewer);
                   }

               }
                )
            //.success(function () { alert("second success"); })
                .error(function (e) {
                    alert("error");
                    //DicomImageViewerUtils.Show(e, "error");
                });
        }
        //.complete(function () { alert("complete"); });


    },


    SetSize: function (data, viewer) {

        if (data.zoom == 0) {
            var cw = (viewer.clientWidth / viewer.data.multiColumns);
            var ch = (viewer.clientHeight / viewer.data.multiRows);
            data.zoom = Math.min(cw / data.size.Width, ch / data.size.Height);
            data.scroll.X = Math.floor((cw - data.size.Width * data.zoom) / 2);
            data.scroll.Y = Math.floor((ch - data.size.Height * data.zoom) / 2);
        }
    },

    SetupRender: function (name, data) {

        var viewerJ = $('#' + name);

        var viewer = viewerJ[0];
        viewer.data = data;

        DicomImageViewer.RenderHtml(viewer);
    },

    RenderHtml: function (viewer) {

        var pos = $(viewer).position();
        var data = viewer.data;

        while (viewer.hasChildNodes()) {
            viewer.removeChild(viewer.lastChild);
        }

        var cw = (viewer.clientWidth / viewer.data.multiColumns);
        var ch = (viewer.clientHeight / viewer.data.multiRows);
        var n = viewer.data.multiRows * viewer.data.multiColumns;
        var dummy = document.createElement("div");
        dummy.style.position = "relative";
        dummy.style.height = "100%";
        dummy.style.width = "100%";
        dummy.style.top = 0;
        dummy.style.left = 0;

        while (viewer.children.length > 0) {
            viewer.removeChild(viewer.firstChild);
        }

        for (var i = 0; i < data.images.length - viewer.data.currentIndex && i < n; i++) {
            var imagediv = document.createElement("div");

            var image = new DicomImageType(imagediv);

            imagediv.image = image;
            imagediv.dicomType = "ImageDiv";

            var r = Math.floor(i / viewer.data.multiColumns);
            var c = i % viewer.data.multiColumns;

            imagediv.style.position = "absolute";
            imagediv.style.height = ch + "px";
            imagediv.style.width = cw + "px";
            imagediv.style.top = r * ch + "px";
            imagediv.style.left = c * cw + "px";

            image.data = data.images[i + viewer.data.currentIndex];
            image.posx = pos.left + c * cw;
            image.posy = pos.top + r * ch;

            var canvas2DSupported = !!window.CanvasRenderingContext2D;
            var html5 = canvas2DSupported && (image.data.html5 === undefined ? viewer.data.html5mode : image.data.html5);

            if (html5) {
                
                image.render = DicomImageViewer.jsDicomViewerRenderCanvas;

                var canvas = document.createElement("canvas");
                canvas.width = cw;
                canvas.height = ch;

                imagediv.appendChild(canvas);

                DicomImageViewer.loadDataHTML5(viewer, image);
            }
            else {
                image.render = DicomImageViewer.jsDicomViewerRenderSvr;
                image.renderSrc = DicomImageViewer.jsDicomImageRenderJpegSrc;

                //frontindex = 0;  // global
                
                var backDiv = document.createElement("div");
                backDiv.style.position = "absolute";
                backDiv.style.height = ch + "px";
                backDiv.style.width = cw + "px";
                var backImage = document.createElement("img");

                backDiv.appendChild(backImage);
                imagediv.appendChild(backDiv);
                frontindex = 1;
                //backindex = 0;  // KEE{ THIS - may be needed
                

                var frontDiv = document.createElement("div");
                frontDiv.style.position = "absolute";
                frontDiv.style.height = ch + "px";
                frontDiv.style.width = cw + "px";
                frontDiv.style.opacity = 1;

                var frontImage = document.createElement("img");

                frontDiv.appendChild(frontImage);
                imagediv.appendChild(frontDiv);
            }

            // common again

            dummy.appendChild(imagediv);
            viewer.appendChild(dummy);

            // finally, once all set up - render it  - common (however!)

            image.render(viewer);
        }
    },

    jsDicomViewerSetCurrentIndex: function (n) {
        this.currentIndex = n;
    },

    findImageParent: function (e) {
        while (e !== null && e.dicomType !== "ImageDiv") {
            e = e.parentElement;
        }
        return e;
    },

    //jsDicomViewerRenderNull: function () { },

    jsDicomViewerRenderCanvas: function (viewer) {

        var image = this;
        var c1 = document.createElement('canvas');

        // faster whilst windowing etc. 
        var quickness = viewer.lastpoint ? 2 : 1;

        //        if (typeof  !== "undefined") {
        //            quickness = 2;
        //        }
        var bestDownSample = DicomImageViewerUtils.power2Round(quickness / image.data.zoom);
        var pd;
        var src = imageData[image.data.id];

        for (var p2 in src) {
            var p1 = src[p2];

            if (p1 !== "requested") {

                if (pd === undefined)
                    pd = p1;
                else if (p1.downsample == bestDownSample)
                    pd = p1;
                else if (p1.downsample < bestDownSample && p1.downsample > pd.downsample)
                    pd = p1;
                else if (p1.downsample < pd.downsample && pd.downsample > bestDownSample) {
                    pd = p1;
                }
            }
        }

        if (pd == undefined || pd.downsample != bestDownSample) {
            DicomImageViewer.loadDataHTML5(viewer, image, bestDownSample);
        }

        if (pd == undefined)
            return;  // bale out!

        c1.width = pd.w;
        c1.height = pd.h;

        var ctx = c1.getContext("2d");

        var imagedata = ctx.createImageData(pd.w, pd.h);

        //msg += (Date.now() - start) + "\n";

        var k = 0;
        var j = 0;

        var width = image.data.width;
        var level = image.data.level;

        var source = pd.p;
        var dest = imagedata.data;
      
        var s = 255 / width;
        var o = 128 - level * s;

        var w = pd.w;
        var h = pd.h;

        var l = h * w;
        j = l;
        k = l * 4;
        do {
            dest[--k] = 255;
            dest[--k] = dest[--k] = dest[--k] = source[--j] * s + o;
        }
        while (j > 0);

        ctx.putImageData(imagedata, 0, 0);

        var c2 = image.imagediv.firstChild;

        var ctx2 = c2.getContext("2d");

        var z = image.data.zoom * pd.downsample;
        var posx = image.data.scroll.X;
        var posy = image.data.scroll.Y;

        // remove "shift" effect

        posx -= (pd.downsample - 1) / 2;
        posy -= (pd.downsample - 1) / 2;

        ctx2.beginPath();
        ctx2.rect(0, 0, c2.width, c2.height);
        ctx2.fillStyle = 'black';
        ctx2.fill();
        ctx2.drawImage(c1, posx, posy, c1.width * z, c1.height * z);
    },

    jsDicomViewerRenderSvr: function (viewer) {

        var image = this;
        var imagediv = image.imagediv;

        var topImage = imagediv.children[frontindex];

        if (typeof image.loaded2 == "undefined" || image.loaded2) {

            //            // leave copy behind until new one loaded
            //            if (typeof backindex !== "undefined" && topImage.children[0].src !== "") {
            //                var backImage = imagediv.children[backindex];
            //                backImage.children[0].src = topImage.children[0].src;
            //            }


            topImage.children[0].onload = function () {
                var ee = topImage.children[0];
                image.loaded2 = true;
                var url = image.renderSrc(viewer, "SVR: " + Math.floor(image.data.width) + "/" + Math.floor(image.data.level), false);

                // check if we have it already (contains)
                if (typeof ee === "undefined" || ee.src.indexOf(url) === -1) {
                    image.render(viewer); // recursive
                }
            };
            image.loaded2 = false;
            topImage.children[0].src = image.renderSrc(viewer, "SVR: " + Math.floor(image.data.width) + "/" + Math.floor(image.data.level), false);
        }

    },

    getPointInfo: function (e, lastPoint) {
        var result = new Object();

        result.isTouch = e.type.indexOf("touch") !== -1;

        if (result.isTouch) {
            result.nPoints = e.originalEvent.touches.length;

            if (e.nPoints < 1) {
                alert("FAIL");
            }

            result.X = e.originalEvent.touches[0].pageX;
            result.Y = e.originalEvent.touches[0].pageY;

            result.elementX = result.X - window.pageXOffset;
            result.elementY = result.Y - window.pageYOffset;

            result.touches = jQuery.extend(true, {}, e.originalEvent.touches);
        }
        else {
            result.X = e.pageX;
            result.Y = e.pageY;
            result.elementX = e.clientX; // e.pageX; // -e.offsetX; 
            result.elementY = e.clientY; // -e.offsetY;
            result.nPoints = 1;
        }

        result.imagediv = DicomImageViewer.findImageParent(document.elementFromPoint(result.elementX, result.elementY));
        if (result.imagediv !== null) {
            result.image = result.imagediv.image;
        }

        if (lastPoint !== undefined) {
            result.dX = result.X - lastPoint.X;
            result.dY = result.Y - lastPoint.Y;
        }

        result.button = e.which;

        result.viewer = result.imagediv.parentElement.parentElement;
        return result;
    }

};


var DicomImageViewerUtils =
{
    distance: function (t, n1, n2) {
        return Math.sqrt(Math.pow(t[n1].pageX - t[n2].pageX, 2) + Math.pow(t[n1].pageY - t[n2].pageY, 2));
    },

    centre: function (t, n1, n2) {
        return { X: (t[n1].pageX + t[n2].pageX) / 2, Y: (t[n1].pageY + t[n2].pageY) / 2 };
    },

    power2Round: function (v) {
        if (v < 1) v = 1;

        return Math.round(Math.pow(2, Math.floor(Math.log(v) * Math.LOG2E + 0.001)));
    },

    Log: function (x) {
        if ($("#TextArea1")[0].innerHTML.length > 1500)
            $("#TextArea1")[0].innerHTML = "";
        $("#TextArea1")[0].innerHTML += x + "\r\n";

    },

    Show: function (e, x) {
        var loggedevent = e;
        var s = "";
        for (ss in loggedevent) {
            //if (typeof loggedevent[ss] !== "function")
            s += ss + " = " + +"\r\n";
        }
        alert(x + ": " + s);
    }

};

var DicomImageType = function (div) {
    this.imagediv = div;
}

DicomImageType.prototype.zoomAt = function (zoom, centre) {

    this.data.scroll.X = this.data.scroll.X * zoom + (centre.X - this.posx) * (1 - zoom);
    this.data.scroll.Y = this.data.scroll.Y * zoom + (centre.Y - this.posy) * (1 - zoom);
    this.data.zoom *= zoom;
};

